<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_UnidadConversionMast.xml */
/* Generado: 2020-08-18 04:21:29 */

/* Mantenimiento de los registros de la tabla MST_UnidadConversionMast */
abstract class BaseMST_UnidadConversionMastDP extends MST_UnidadConversionMastBV
{
    /* Constructor ( Establece los valores desde un objeto MST_UnidadConversionMastBN ) */
    public function __construct( MST_UnidadConversionMastBN $o_MST_UnidadConversionMastBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_MST_UnidadConversionMastBN ) )
        {
            $this->setByBN( $o_MST_UnidadConversionMastBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto MST_UnidadConversionMastBN */
    public function setByBN( MST_UnidadConversionMastBN $o_MST_UnidadConversionMastBN )
    {
        if ( !is_null( $o_MST_UnidadConversionMastBN->getIdUnidad() ) )
        {
            $this->setIdUnidad( $o_MST_UnidadConversionMastBN->getIdUnidad() );
        }
        if ( !is_null( $o_MST_UnidadConversionMastBN->getIdUnidadEquivalente() ) )
        {
            $this->setIdUnidadEquivalente( $o_MST_UnidadConversionMastBN->getIdUnidadEquivalente() );
        }
        if ( !is_null( $o_MST_UnidadConversionMastBN->getCantidadEquivalente() ) )
        {
            $this->setCantidadEquivalente( $o_MST_UnidadConversionMastBN->getCantidadEquivalente() );
        }
        if ( !is_null( $o_MST_UnidadConversionMastBN->getSecuencia() ) )
        {
            $this->setSecuencia( $o_MST_UnidadConversionMastBN->getSecuencia() );
        }
        if ( !is_null( $o_MST_UnidadConversionMastBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_UnidadConversionMastBN->getEstado() );
        }
        if ( !is_null( $o_MST_UnidadConversionMastBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_UnidadConversionMastBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_UnidadConversionMastBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_UnidadConversionMastBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_UnidadConversionMastBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_UnidadConversionMastBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_UnidadConversionMastBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_UnidadConversionMastBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_MST_UnidadConversionMastFN = new MST_UnidadConversionMastFN();
        $o_MST_UnidadConversionMastBN = $o_MST_UnidadConversionMastFN->selectByPk( $this->getIdUnidad(), $this->getIdUnidadEquivalente() );
        if ( is_null( $o_MST_UnidadConversionMastBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO MST_UnidadConversionMast ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdUnidad() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUnidad";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdUnidad()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdUnidadEquivalente() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUnidadEquivalente";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdUnidadEquivalente()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCantidadEquivalente() ) )
            {
                $s_SQLQuery1 .= $s_Separator."CantidadEquivalente";
                $s_SQLQuery2 .= $s_Separator."".$this->getCantidadEquivalente()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSecuencia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Secuencia";
                $s_SQLQuery2 .= $s_Separator."".$this->getSecuencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE MST_UnidadConversionMast SET ";
            $s_Separator = "";
            if ( !is_null( $this->getCantidadEquivalente() ) )
            {
                $s_SQLQuery .= $s_Separator."CantidadEquivalente = ".$this->getCantidadEquivalente()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSecuencia() ) )
            {
                $s_SQLQuery .= $s_Separator."Secuencia = ".$this->getSecuencia()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdUnidad = '".$this->getIdUnidad()."' AND  IdUnidadEquivalente = '".$this->getIdUnidadEquivalente()."';";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM MST_UnidadConversionMast WHERE  IdUnidad = '".$this->getIdUnidad()."' AND  IdUnidadEquivalente = '".$this->getIdUnidadEquivalente()."';";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>